Subject: Re: bug#16348: 24.3.50; Increasing internal-border-width cuts menubar and toolbar on non-toolkit builds

From: Eli Zaretskii <[email-masked]>
Date: Sun, 05 Jan 2014 22:04:20 +0200

> Date: Sun, 05 Jan 2014 21:22:34 +0200
> From: Eli Zaretskii <[email-masked]>
> Cc: [email-masked]
> 
> > Date: Sun, 05 Jan 2014 19:38:39 +0100
> > From: martin rudalics <[email-masked]>
> > CC: [email-masked], [email-masked]
> > 
> >  > I meant if I'm wrong about disabling the current matrix's rows.
> > 
> > You mean call clear_glyph_matrix for all windows?
> 
> I guess so, for all windows on the frame.
> 
> > Which matrices?
> 
> The current ones, I think.

But the problem doesn't seem to be related to portions of the frame
not being redrawn in the test case you sent, i.e.:

  (progn
     (set-frame-parameter (selected-frame) 'scroll-bar-width 6)
     (sit-for 1)
     (set-frame-parameter (selected-frame) 'left-fringe 27)
     (sit-for 1)
     (set-frame-parameter (selected-frame) 'scroll-bar-width 6)
     (sit-for 1))

What seems to be happening here is that changing the left fringe to 27
pixels confuses Emacs about the dimensions of the text area, because
the right fringe disappears and the text area becomes wider than it
should be.

So I'm not sure the problem here is with redisplay optimizations at
all.